package hexIT;

import java.lang.*;
import java.util.*;


/**
 * A diamond board is a board arranged like a diamond, as seen below.
 * The board depicted below has size 4.
 *
 * <pre>
 * Coord System & Example:
 *
 *                            (y-coord)
 *                   0 1 2 3
 *                  / / / /
 * (x-coord)    0- . . . .
 *             1- . . x .   <-- that 'x' is at (1,2)
 *            2- . . . .
 *           3- . . . .
 *
 * </pre>
 *
 * @author Marc Lanctot
 * @version 1.0
 * @last modified: Oct 6, 2003
 * @changes: comments added
 */
public class DiamondBoard extends Board
{
   private Hexagon[][]   tiles;     // coords stored as [x][y]
   private int sideLength;          // in tiles

	/** Creates a new diamond board of the specified size. */
   public DiamondBoard(int new_size)
   {
      super(new_size);

      sideLength= size;

      tiles= new Hexagon[sideLength][sideLength];

      // create the empty tiles
      for (int i= 0; i < sideLength; i++)
         for (int j= 0; j < sideLength; j++)
            tiles[i][j]= new Hexagon(i, j);
   }

   /** Calculates the minimum # of hexes need to travel from one to the other. */
   public int distance(Hexagon h1, Hexagon h2)
   {
      return (Misc.abs(h2.getHexX()-h1.getHexX()) +
		        Misc.abs(h2.getHexY()-h1.getHexY()));
   }

   /** Unimplemented. See description in superclass. */
   public Iterator tilesIterator()
   {
      return null;
   }

   /** Unimplemented. See description in superclass. */
   public List getSurrounding(int hexx, int hexy, int radius)
   {
      return null;
   }

   /** Unimplemented. See description in superclass. */
   public List getLOS(int hexx1, int hexy1, int hexx2, int hexy2)
   {
      return null;
   }

   /** Unimplemented. See description in superclass. */
   public List getShortestPath(int hexx1, int hexy1, int hexx2, int hexy2)
	{
		return null;
	}

   /** Unimplemented. See description in superclass. */
   public java.util.List getFOV(int hexx1, int hexy1, int maxradius)
	{
		return null;
	}

   /** Unimplemented. See description in superclass. */
	public java.util.List getExterior()
	{
		return null;
	}
}
