package hexIT;

import java.lang.*;
import java.awt.*;

/**
 *  A drawable object is any object that can be drawn to the screen.
 *  This means that it has an image associated with it, that is used
 *  when representing the object on the hex board. All objects to be
 *  drawn on the board should implement this interface; also, ImageTools
 *  can be used to load images from disk. One can also use DrawableAdapter
 *  as a quick way to instantiate a drawable object. 
 *
 * @author Marc Lanctot
 * @version 1.0
 * @last modified: Oct 6, 2003
 * @changes: comments added
 */
public interface Drawable
{
   /** 
    *  Returns the image represented by this drawable object.
    *  Returns null if currently no image set for this object.
    */
   public Image getImage();

	/**
	 *  Sets the image of this object to the specified image.
	 */
   public void setImage(Image new_image);
}
   
