package hexIT;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*; //  URL

public class HexApplet extends JApplet
{
   // the main GUI frame
   private HexFrame mainFrame;
   
   private int boardtype,  // HexFrame.XXXXXX .. 
	            size,       // the size of the board
					width, height; // pixels sizes for the frame
  
	private String name;
					
   /**
    *  Initializes the applet. This gets the codebase and sets up the network information
    *  to connect to the ID&DE server. This sets the port to the ID&DE standar port (8891)
    *  and the hostname to the hostname of the server. It also does some configuration work
    *  in Core.Config and lets the configuration know it won't be loading from any files.
    *
    *  <br><br>
    *  @see Core.Config
    */
   public void init() 
   {
		// these parameters come from the HTML file
      boardtype= Integer.parseInt(getParameter("boardtype")); 
      size= Integer.parseInt(getParameter("size")); 
      width= Integer.parseInt(getParameter("width")); 
      height= Integer.parseInt(getParameter("height")); 
		name= getParameter("name");

		System.out.println(boardtype+";"+size+";"+width+";"+height+";"+name);
		mainFrame= new HexFrame(name, width, height, boardtype, size, Color.black);
   }

   /**
    *  Start the applet client. This function connects to the ID&DE server with the same hostname
    *  as the webserver, and port set during initialization. It also gets the main frame from the
    *  GUI to show to the applet viewers.
    */
   public void start()
   {
		mainFrame.setVisible(true);
   }
      
   /**
    *  Show an error message.
    *
    *  @param message         the error message to display
    */
   public void showErrorMessage(String message)
   {
      JOptionPane.showMessageDialog(mainFrame, message, "Error", JOptionPane.ERROR_MESSAGE);
   }  

   /** 
    *  Dispose of the main frame. 
    */
   public void DisposeFrame()
   {
      mainFrame.setVisible(false);
      mainFrame.dispose();
   }

	public String getHost()
	{
		return getCodeBase().getHost();
	}
}
