package hexIT;

import java.lang.*;
import java.util.*;

/**
 *  This is a helper class that supplies miscellaneous functions
 *  that are convenient to have package-wide.
 *
 * @author Marc Lanctot
 * @version 1.0
 * @last modified: Oct 6, 2003
 * @changes: comments added
 */
public class Misc
{
	private static Random RNG= new Random();

   /**
	 *  Returns the minimum of 2 integers, but never less than 0.
	 *  If the minimum is less than 0, 0 is returned.
	 */
   protected static int absmin(int num1, int num2)
   {
      int min= (num1 < num2 ? num1 : num2);
      return (min < 0 ? 0 : min);
   }

	/** Returns the absolute value of the specified integer. */
   protected static int abs(int num)
   {
      return (num < 0 ? (-num) : num);
   }

	/** Returns the maximum value of the specified integers. */
   protected static int max(int num1, int num2)
   {
      return (num1 > num2 ? num1 : num2);
   }

	/** Returns 1 if num is positive, -1 if it's negative and 0 otherwise. */
   protected static int sign(int num)
   {
      if (num > 0)
         return 1;
      else if (num < 0)
         return -1;
      else
         return 0;
   }

	/**
	 *  Returns the union of the contents of 2 lists. Equality of 2 elements
	 *  is determined by the objects' equals() methods. This method is immutable:
	 *  the lists passed in as arguments are not modified.
	 */
	protected static List union(List l1, List l2)
	{
		LinkedList result= new LinkedList();
		List other;

		if (l1.size() > l2.size())
		{ result.addAll(l1); other= l2; }
		else
		{ result.addAll(l2); other= l1; }

		Iterator i= other.listIterator();

		while (i.hasNext())
		{
			Object o= i.next();
			if (!result.contains(o))
				result.add(o);
		}

		return result;
	}

	/** Generates a uniformly random number between high and low, inclusive */
	public static int UniformRandom(int low, int high)
	{
		return (RNG.nextInt(high-low) + low + 1);
	}


}
